<?php

  	function readParam($filename) {
         global $SystemeEquation, $LesReactions;
	 $fd=fopen($filename, "r");
		$type_lecture_courante="";
		$chaines_lecture=array(""=>0,  "SystemeEquation"=>1, "LesReactions"=>2);
		while (!feof($fd)) {
		
   	switch ($chaines_lecture[$type_lecture_courante]) {

				case 1: // lecture SystemeEquation
					$i=0;
					do {
						$ligne=trim(fgets($fd,65536));
						if (strcmp($ligne,"END") != 0) {
							if ($ligne != "") $SystemeEquation[$i++]=explode(";",$ligne);
						}
					} while ((! feof($fd)) && (strcmp($ligne,"END") != 0));
					$type_lecture_courante="";
				break;
				case 2: // lecture LesReactions
					$i=0;
					do {
						$ligne=trim(fgets($fd,4096));
						if (strcmp($ligne,"END") != 0) {
					                   $LesReactions[$i++]=$ligne;
						}
					} while ((!feof($fd)) && (strcmp($ligne,"END") != 0));
					$type_lecture_courante="";
				default: // reste
					$ligne=trim(fgets($fd,4096));
					$type=substr($ligne,6);
					if (strcmp(substr($ligne,0,5),"BEGIN") == 0)
						if (isset($chaines_lecture[$type])) 
							$type_lecture_courante=$type;
				
		}
    }
	fclose($fd);
	}
	
	$filename ="SystemConstraints.txt";
if( file_exists($filename) ){
readParam($filename);
}




///crée un dossier tmp
$dossier="tmp";
if( !file_exists($dossier) ){
mkdir("tmp");

}


function suppression($dossier_traite , $extension_fichier, $age_fichier){
         $Repertoire = opendir($dossier_traite);
		 while($fichier = readdir($Repertoire)){
		       $chemin = $dossier_traite."/". $fichier;
			  $infos = pathinfo($chemin);
			   if(isset($infos["extension"]))
				$extension = $infos["extension"];
			  else $extension = ""; 
			   $age = time() - filemtime($chemin);
		       if($fichier != ".." || $fichier != "." )
			    
			      if($extension == $extension_fichier && $age > $age_fichier)
                             
			         unlink($dossier_traite."/".$fichier);
		 }
		 closedir($Repertoire);
}

function comparaisonSolution(&$tab,  &$ind){
			global $Colonne_test, $solutions_diff1 ;
			for($i=$ind; $i<count($tab); $i++){
						$tab1= $tab[$i];

						$compteur=0;
						for($j=0; $j<count($solutions_diff1); $j++){
									$tab2= $solutions_diff1[$j];
									$diff=array();
									$diff= array_diff_assoc($tab1, $tab2);
									if(count($diff)>0) $compteur++;
						}
						if( $compteur == count($solutions_diff1) ){
									$solutions_diff1[]=$tab1;
									//$tab[]=$tab1;
						}
					
						$ind++;

			}

}
$coef_CO2=array(6=>1,7=>1,8=>1,9=>-1,10=>1, 11=>1,22=>1,25=>0.5);

//$num_CO2=array('6'=>'9','7'=>'10','8'=>'11','9'=>'13','10'=>'14' 11=>15,22=>30,25=>33);


$lenghtObj=count($SystemeEquation[0])-1;
$optimum = 0;
$leTemps=time();

include("SimplexAlgorithm.php");	

$solutions_inf=0;
$compt=-1;
$compteur=0;
$T=array();
$solutions_diff1=array();
//$entier_min=-50;
$nbreObject=$argv[1];

echo "please wait"."\n";
for($obj=0; $obj<$nbreObject; $obj++){
		      $SortieSimplexe= "tmp/SortieSimplexe_".$obj.".txt";
        $MesValeurs = fopen($SortieSimplexe,'w');				
        
								$sortiephp2= "tmp/sortiephp_".$obj.".txt";
								$fd=fopen($sortiephp2, "w");
								for($i=0; $i<count($SystemeEquation); $i++){

											$inequality=$SystemeEquation[$i][0];
											if ($inequality=="<") fprintf($fd,"<;");
											elseif ($inequality==">") fprintf($fd,">;");
											elseif ($inequality=="=") fprintf($fd,"=;");
											if ($inequality!="m"){
														for($j=1; $j<count($SystemeEquation[$i])-1; $j++){
																	$valeur=$SystemeEquation[$i][$j];
																	fprintf($fd,"%f;", $valeur);
														}
														fprintf($fd, "\n");
											}

								}



								fprintf($fd,"m;");
								for($j=1; $j<$lenghtObj; $j++){ 
											$nb_aleat=2*mt_rand()/mt_getrandmax()-1;

											fprintf($fd,"%f;", $nb_aleat);
								}
								fclose($fd);



					$Problem=new LinearProblem();

					$Problem->FromFile($sortiephp2);
					$artifcode = False;

					if ($artifcode)
										 $JLIM = $Problem->N + $Problem->G + $Problem->M + 1;    
							else
										 $JLIM = $Problem->N + $Problem->G + $Problem->L + 1;
							$displaycode = 1;
								
							$Basis = array();
				

							$LPcode = linpro ($Problem, $artifcode,	$Basis, $displaycode);
fclose($MesValeurs);

$Colonne2=array();
$Colonne1=array();

$fd=fopen($SortieSimplexe, "r");

//les coefficients du simplexe et leurs valeurs
while($ligne = fgetcsv($fd,9999,";")){
$Colonne1[]= $ligne[1];
} 
fclose($fd);

for($i=0; $i<count($Colonne1)-1; $i++){
$Colonne2[]= $Colonne1[$i];
}
$a=0;
for($i=0; $i<count($Colonne2); $i++){
$a= $a+$Colonne2[$i];
}
$CO2=0;
$CO2= $coef_CO2[6]*$Colonne2[6]+$coef_CO2[7]*$Colonne2[7]+$coef_CO2[8]*$Colonne2[8]+$coef_CO2[9]*$Colonne2[9]+$coef_CO2[10]*$Colonne2[10]+$coef_CO2[11]*$Colonne2[11]+$coef_CO2[22]*$Colonne2[22]+$coef_CO2[25]*$Colonne2[25];
$Colonne2[]= $CO2;
$Colonne2[]= $CO2;



if( (count($Colonne2) != 0) && $a<1e50 ){
					$compt++;
					$Colonne_test[$compt]=array();
					$Colonne_test[$compt]=$Colonne2;
     if( count($Colonne_test)==1 ){
     $c=1;
					if( !isset($T[$c]) ){
									$T[$c]=1;
									$solutions_diff1[]=$Colonne_test[0];

					}
					$tab0[]=$Colonne_test[0];
					$ind0=0;
					$a=comparaisonSolution($tab0, $ind0);
					$Colonne_test[0]=array();
					$compt=-1;
     }

}


if( count($Colonne2) == 0 ) $solutions_inf++;



suppression("tmp", "txt", "6000");


}//Pour itération sur les objectifs

//print_r($num_CO2);
$nbsommets=count($solutions_diff1);
echo "YOU HAVE ".$nbsommets. " VERTICES\n";

//print_r($LesReactions);
//print_r($Colonne2);


for ($i=0; $i<$nbsommets; $i++){
$sommet = $i+1;
echo "VERTEX ".$sommet."\n";
for($j=0; $j<count($LesReactions); $j++){
$num=$LesReactions[$j];
$val=$Colonne2[$j];
echo "R_".$num."->".$val."\n";

}


}






?>
