

<?php



/*
file            pl_solver.php
author      
source      translation  from BASIC to C/C++ to Python to php
                of G.E. linpro program.
revisions   
*/

//from matlib import matzero, matdim, matprint, matsetblock   $nomfich




		   
		
class LinearProblem {
        //var $Z=0;
	//var $dimx=0;
	//var $dimy=0;
	var $M=0;
	var $L=0;
	var $E=0;
	var $G=0;
	var $N=0;
    var $optim=1;
	var $values=array();
	function getXY($x,$y) {return (isset($this->values[$x.",".$y]))?$this->values[$x.",".$y]:0;}
	function setXY($x,$y,$v) {$this->values[$x.",".$y]=$v;}//if ($x>=$this->dimx)$this->dimx=$x+1;if ($y>=$this->dimy) $this->dimy=$y+1;
	//function matzero() {return (($this->dimx==0) && ($this->dimy==0));}
	function FromFile($nomfich) {
                /*
                $fd=fopen($nomfich,"r");
                $i=0;
                while($Matrice[$i++]=fgetcsv($fd,4096,";")){
                }
                fclose($fd);
                $this->Z=$this->count($Matrice[0])-1;
                */
                $fd=fopen($nomfich,"r");
                $l=0;
		$LOWER=array();
		$GREATER=array();
		$EQUAL=array();
		while($ligne=fgetcsv($fd,4096,";")) {
			if ($ligne[0] == "<") $LOWER[]=$ligne;
			if ($ligne[0] == "=") $EQUAL[]=$ligne;
			if ($ligne[0] == ">") $GREATER[]=$ligne;
			if (($ligne[0] == "m") || ($ligne[0] == "M")) $OBJECTIVE=$ligne;

		}
		fclose($fd);
		$this->L=count($LOWER);
		for($i=0;$i<count($LOWER); $i++) {
			$ligne=$LOWER[$i];
			//count($ligne)=(count($ligne)>count($ligne))?count($ligne):count($ligne);
			for($c=1; $c<count($ligne); $c++)
				$this->setXY($l,$c-1,$ligne[$c]);
			$l++;
                
		}
		$this->E=count($EQUAL);
		for($i=0;$i<count($EQUAL); $i++) {
			$ligne=$EQUAL[$i];
			//count($ligne)=(count($ligne)>count($ligne))?count($ligne):count($ligne);
			for($c=1; $c<count($ligne); $c++)
				$this->setXY($l,$c-1,$ligne[$c]);
			$l++;
		}
		$this->G=count($GREATER);
		for($i=0;$i<count($GREATER); $i++) {
			$ligne=$GREATER[$i];
			//count($ligne)=(count($ligne)>count($ligne))?count($ligne):count($ligne);
			for($c=1; $c<count($ligne); $c++)
				$this->setXY($l,$c-1,$ligne[$c]);
			$l++;
		}
		$this->optim=($OBJECTIVE[0] == "m")?1:0;
		for($c=1; $c<count($ligne); $c++)
			$this->setXY($l,$c-1,$OBJECTIVE[$c]);
		
		//count($ligne)--;
		$this->dimy=$l;
		//$this->NL=count($ligne)-3;
		$this->N=count($ligne)-3;
		$this->M=$l;
	}
}//Pour la classe  LinearProblem
 function disp_Basis(&$AA, $opticode, $LPIter, $Basis, $M) {
     global $optimum, $lenghtObj, $MesValeurs ;   

      $NbreVariable=$lenghtObj-2;
   
      $Maximo=$NbreVariable+1;

      $classement1=array();
      $classement2=array();
     
      $test=array();
      for($j=1; $j<$Maximo; $j++ ){
                 $classement1[]=$j;
      }
      $zero=0; 
		//				$leTemps=time();
			//			$SortieSimplexe="tmp/SortieSimplexe_".$leTemps.".txt";

  //    $MesValeurs = fopen($SortieSimplexe,'w');
  //    fprintf("<br/>");


      for($sub_i = 0; $sub_i < $M; $sub_i++){
         if ( $Basis[$sub_i] <= $NbreVariable) 
                   $classement2[]=$Basis[$sub_i];


      } 

      
          for($l=1; $l< $Maximo; $l++){
            for($sub_i = 0; $sub_i < $M; $sub_i++){
         
               if ( $Basis[$sub_i] <= $NbreVariable && $Basis[$sub_i] == $l) {
                    fprintf($MesValeurs, "%d;%f\n", $Basis[$sub_i],$AA->getXY($sub_i,0));
                 }
             } 
            if (in_array($l, $classement1) && !in_array($l, $classement2) ) {
               
               fprintf($MesValeurs, "%d;%f\n", $l,$zero);         
     
           }    
          }
		   if(isset($optimum))
            fprintf($MesValeurs, "%s;%f\n","Objectif",$AA->getXY($M,0));
           else
		    fprintf($MesValeurs, "%s;%f\n","Objectif", -$AA->getXY($M,0));
     
  //    fclose($MesValeurs);
		  
           
}

function linpro (& $AA,$artifcode, &$Basis, $disp_code, $ZTOL = 1.0e-6){
  global $optimum, $MesValeurs, $SortieSimplexe ;
/*
  Parameters
  AA           AA is a dynamically allocated matrix
  and should be dimensioned (M+2) * JLIM
  where
  JLIM = N + G + L + 1 if artifcode = 0
  and
  JLIM = N + G + M + 1 if artifcode = 1.

  B coefficients are stored in AA[ ][0]
  Z coefficients are stored in AA[M][]
  Phase 1 coefficients are stored in AA[M+1][]

  M             Number of constraint equations
  N             Number of variables
  L             Number of less thans
  E             Number of equal tos
  G             Number of greater thans

  artifcode
  0 - do not process artificial variables,
  1 - otherwise

  opticode
  0 - minimization
  1 - maximization

  Basis[]  Output current Basis column.
  Variables are numbered 1 to L+E+G.

  LPcode   Return LPcode code of LP routine:
  0 - Successful
  1 - Array too small
  2 - Inconsistent equations
  3 - B coefficients must be positive !
  4 - Infeasible, artificial variable in solution
  5 - No solution, unbounded solution
  6 - Excessive number of iterations
  7 - Failed to allocate space for VC
   
  disp_code
  0   no display
  1   for display of results only
  2   for display of Basis and objective function
  3   for display of tableau at each iteration

  Description
  This is a C++ translation of the G.E.(General Electric)
  LINPRO program.
  */




/* 
 function disp_Basis(&$AA, $opticode, $LPIter, $Basis, $M) {
     global $optimum, $sortiephp2, $SortieSimplexe;   
     $fd=fopen($sortiephp2,"r");
     $i=0;
     while($Matrice[$i++]=fgetcsv($fd,4096,";")){
     }
     fclose($fd);
      $NbreVariable=count($Matrice[0])-3;
      echo "nbre de variable=". $NbreVariable;
      $Maximo=$NbreVariable+1;

      $classement1=array();
      $classement2=array();
     
      $test=array();
      for($j=1; $j<$Maximo; $j++ ){
                 $classement1[]=$j;
      }
      $zero=0; 
      $MesValeurs = fopen($SortieSimplexe,'w');
      fprintf("<br/>");
      $reste= fopen('tmp/Sortie.txt','w');
      for($sub_i = 0; $sub_i < $M; $sub_i++){
         if ( $Basis[$sub_i] <= $NbreVariable) 
                   $classement2[]=$Basis[$sub_i];
        else 
            fprintf($reste, "%d;%f\n", $Basis[$sub_i],$AA->getXY($sub_i,0));

      } 

      
          for($l=1; $l< $Maximo; $l++){
            for($sub_i = 0; $sub_i < $M; $sub_i++){
         
               if ( $Basis[$sub_i] <= $NbreVariable && $Basis[$sub_i] == $l) {
                    fprintf($MesValeurs, "%d;%f\n", $Basis[$sub_i],$AA->getXY($sub_i,0));
                 }
             } 
            if (in_array($l, $classement1) && !in_array($l, $classement2) ) {
               
               fprintf($MesValeurs, "%d;%f\n", $l,$zero);         
               fprintf($reste, "%d;%f\n", $l,$zero); 
           }    
          }
		   if(isset($optimum))
            fprintf($MesValeurs, "%s;%f\n","Objectif",$AA->getXY($M,0));
           else
		    fprintf($MesValeurs, "%s;%f\n","Objectif", -$AA->getXY($M,0));
     
           fclose($MesValeurs);
		   fclose($reste);
           
}
 */
 

$M=$AA->M;
$N=$AA->N;
$L=$AA->L;
$E=$AA->E;
$G=$AA->G;
$opticode=$AA->optim;
$MAXDOUBLE = 1.0e100;
//printf("M=".$M);
//printf("<br/>");
//printf("N=".$N);
//printf("<br/>");
//printf("L=".$L);
//printf("<br/>");
//printf("E=".$E);
//printf("<br/>");
//printf("G=".$G);
//printf("<br/>");
		$a=0;

  $K = $N + $G + $M + 1;
  if ($artifcode)
      $JLIM = $K;
  else
      $JLIM = $N + $G + $L + 1;
  


  # Check for  size of AA, and equation for L, E and G 
  //$nrows = $AA->dimy+1;
  //$ncols  = 4*$AA->dimx;
    
  //printf("nrows = %d",$nrows);

  //printf("ncols = %d",$ncols);
  
  /*
  if (($nrows < $M + 2) || ($ncols < $JLIM)) {
      $LPcode = 1;		#  Array too small  
      return $LPcode;

  } else
  */
  if ($L + $E + $G != $M) {
       printf("<br/>");
                        printf(" Pas de Solution.");
                        printf("<br/>");
                        
                        fprintf($MesValeurs, "Pas de solution");
                       
      $LPcode = 2;		#  Inconsistent equations. 
      return $LPcode;
  }

  # Check for B 
  for($I = 0; $I < $M; $I++) 
      if ($AA->getXY($I,0) < 0.0) {
       printf("<br/>");
       printf(" Pas de Solution.");
       printf("<br/>");
      
       fprintf($MesValeurs, "Pas de solution");
 
       $LPcode = 3;
       return $LPcode;
      }
    

  # Initialize the Basis 
  for($I = 0; $I < $M; $I++)
      $Basis[$I] = $I + 1 + $N + $G;
    
  for($I = $M; $I <= $M + 1; $I++)
      $Basis[$I] = 0;
    


  # Initialize the Variable Header  
  $VC = array(); 
  for($i=1; $i<$JLIM; $i++) $VC[$i]=$i;    

  # Initialize to zero the surplus and slack regions
  //$B = $N + $G + $M + 1;
  for($I = 0; $I <= $M + 1; $I++)
      for($J = $N + 1; $J < $JLIM; $J++)
		  $AA->setXY($I,$J,0.0);
	
    

  # The  surplus part
  $J = $N + 1;
  for($I = $L + $E; $I < $M; $I++) {
      $AA->setXY($I,$J,-1.0);
      $J++;
  }
    

  # The slack part of the array (include artificial
  # part if JLIM == K)
  $J = $N + $G + 1;
  for($I = 0; $I < $M; $I++) {
     //for($J=$N+$G+1; $J<$JLIM; $J++)
      $AA->setXY($I,$J,1.0);
      $J++;
      if ($J >= $JLIM) break;
  }
    

  # Negate the objective coefficients for
  # maximization problems
  if ($opticode == 1)
      for($J = 1; $J < $JLIM; $J++)
		  $AA->setXY($M,$J,-$AA->getXY($M,$J));
	
  # Compute the last row for phase 1 
  
  $do_phase1 = ($G + $E == 0)? False : True;
   //$do_phase1 = False;
    
  if ($do_phase1) {
      $JLIM_2=$N+$G+1;
      for($J = 0; $J < $JLIM_2; $J++) {
	     $RSum = 0.0;
	     for($I = $L; $I < $M; $I++)
	      $RSum = $RSum + $AA->getXY($I,$J);	    
	     $AA->setXY($M + 1,$J,-$RSum);
      }
  } else {
      for($J = 0; $J < $JLIM; $J++)
		    $AA->setXY($M + 1,$J,0.0); ///////////////////////////////////////////////////////////////////////////////////////////
  }
    
  $Test_Row = ($do_phase1)? $M + 1:$M;
  $Previous_objectif = 0;
  $Next_objectif = 0;
  $essai = 0;
  $variables_increasing_objectif = array();
  $variables_decreasing_objectif = array();
  $variables_noImpact_objectif = array();
   $T = array();
  $maxLPIter =  2*$K;
  for($LPIter = 1; $LPIter <= $maxLPIter; $LPIter++) {

      # Step 1:  find pivot column 
    while (1) {
	  	if ($disp_code == 2) disp_Basis($AA, $opticode, $LPIter, $Basis, $M);
	  	if ($disp_code == 3) disp_Tableau($AA, $LPIter, $Basis, $M, $VC, $JLIM);
      
	  # find the most negative number in the test row 
	  	$tempR = 0.0;
	  	$Piv_Col = 0;

	  	for($J = $JLIM - 1; $J >= 1; $J--) {
	      	$R = $AA->getXY($Test_Row,$J);
	      	   if ($R < $tempR){
		  		           if ($do_phase1 || ($AA->getXY($Test_Row + 1,$J) == 0)) {
		      	           $tempR = $R;
		      	           $Piv_Col = $J;
		  		   
			              }
           }
		}
		  			    
		if (($Piv_Col == 0) && $do_phase1) {
	      	$Test_Row--;
	      	$do_phase1 = False;
				 //   printf("<br/>");
	       if ($disp_code == 3)
		  		  printf("\n End of Phase 1 \n");
			//	    printf("<br/>");
                    
	  	}
    else 
        break;
                
	  } // pour while
	
   $JLIM_1 = $JLIM;
   if ($Piv_Col == 0) {
	     for($I = 0; $I < $M; $I++){
        if (($Basis[$I] >= $JLIM_1 ) && (abs ($AA->getXY($I,0)) > $ZTOL)) {
		  	       if ($disp_code >= 1){
//		              printf("\n Artificial variable in solution.\n");
            //    printf("<br/>");
           //     printf(" Pas de Solution.");
           //     printf("<br/>");
            
//                fprintf($MesValeurs, "Artificial variable in solution");
        
		  	           $LPcode = 4;
                return $LPcode;
            }
         }
	    }
	   

	  	if ($disp_code >= 1) {
//							$a++;
	      disp_Basis($AA, $opticode, $LPIter, $Basis, $M);
//	      printf("\nSuccesful termination\n");
//    echo "/////".$a."//////";
	  	}
	  	$LPcode = 0;		# successful termination 
	  	return $LPcode;
 }
	

      # Step 2: Find pivot row 
      $R = $MAXDOUBLE;
      $Piv_Row = -1;
      $Tie_Row = $K + 2;

     for($I = $M - 1; $I >= 0; $I--) {
	  	    $tempR = $AA->getXY($I,$Piv_Col);
	  	    if ($tempR > $ZTOL) {
	   		     $Ratio = abs ($AA->getXY($I,0) / $tempR);
	      	   if ($Ratio < $R) {
		  		     $R = $Ratio;
		  		     $Piv_Row = $I;
	      	   }
		         elseif ($Ratio == $R){
		  		     //  if ($Basis[$Tie_Row] > $Basis[$I])
		      		  $Piv_Row = $I;
          }
	    	    $Tie_Row = $Basis[$I];
			     }
    }

	   if ($Piv_Row == -1) {
	  	   if ($disp_code >= 1){
//	         printf("\nUnbounded Solution\n");

//						$leTemps=time();
//						$SortieSimplexe="tmp/SortieSimplexe_".$leTemps.".txt";
//     $MesValeurs=fopen($SortieSimplexe, "w");
//          fprintf($MesValeurs, "Unbounded Solution");
 //     fclose($MesValeurs);

		        $LPcode = 5;
          return  $LPcode;
       }
    }
	
      if ($disp_code >= 2)
	  	printf("\n Pivot Row: %d, Pivot Column: %d \n",$Piv_Row, $Piv_Col);
      
	

      # Step 3: Reduce the array 
      $invPivot = 1.0 / $AA->getXY($Piv_Row,$Piv_Col);
	  
    for($I = 0; $I <= $Test_Row ;$I++) {
	  	    $R = $AA->getXY($I,$Piv_Col) * $invPivot;
	  	    if ($I != $Piv_Row) {
	          for($J = 0; $J < $JLIM; $J++) {
		  	         if ($J != $Piv_Col){
			              $AA->setXY($I,$J,$AA->getXY($I,$J) - $AA->getXY($Piv_Row,$J) * $R);
				             if (abs ($AA->getXY($I,$J)) <= $ZTOL) $AA->setXY($I,$J,0.0);
                 if( $I==($M+1) ){
                    
						              $Next_objectif=$AA->getXY($I,0);
                    //echo "suivant".$Next_objectif;
                     //echo "precedent".  $Previous_objectif;
                     if (!isset($T[$Piv_Col])){
                          $T[$Piv_Col]=1;
																          if( $Next_objectif < $Previous_objectif)  $variables_decreasing_objectif[]=$Piv_Col;
																          elseif($Next_objectif > $Previous_objectif) $variables_increasing_objectif[]=$Piv_Col;
																          else  $variables_noImpact_objectif[]=$Piv_Col;

										                 $Previous_objectif=$Next_objectif;

                    }
                  
              }
	          }


						        
								      $AA->setXY($I,$Piv_Col,0.0);
           }

	  	  }
    }
  

	
      for($J = 0; $J < $JLIM; $J++){
	    $AA->setXY($Piv_Row,$J,$AA->getXY($Piv_Row,$J) * $invPivot);
		
      }	
      $AA->setXY($Piv_Row,$Piv_Col,1.0);

      # Step 4: replace old Basis variable 
      $VC[$Piv_Col] = $Basis[$Piv_Row];
      $Basis[$Piv_Row] = $Piv_Col;
	
} //pour le for de LPIter
 
   
  
    

  if ($disp_code >= 1)
      printf("Maximum iterations exceeded.\n");
     // printf("<br/>");
     // printf(" Pas de Solution.");
     // printf("<br/>");
  
      fprintf($MesValeurs, "Maximum iterations exceeded");

      $LPcode = 6;
      return  $LPcode;





}


/*
$Problem=new LinearProblem();
$Problem->FromFile("sortiephp.txt");

$artifcode = False;
if ($artifcode)
      $JLIM = $Problem->N + $Problem->G + $Problem->M + 1;    
else
   $JLIM = $Problem->N + $Problem->G + $Problem->L + 1;
   $displaycode = 3;
    
   $Basis = array();
  
   $LPcode = linpro ($Problem, $artifcode,	$Basis, $displaycode);

//   printf(" LP routine exit code:%d \n",$LPcode);
//   printf("<br/>");
 
  */   


?>




